#!/usr/bin/python
"""
This file is part of The Free Python Web Server Project (FreePyWebServer).
Copyright (C) 2008 Collin Ross Mechlowitz Stocks.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

import re

def processRequest(data,addr):
	try:
		r_end=data.replace('\r','\n').index('\n')
		m=re.match("^\\s*(\\S+)\\s+(\\S+)\\s+(\\S+)\\s*$",data[:r_end])
		method,resource,version=m.groups()
		if not method.upper() in ["HEAD","GET","POST"]:
			return 501,"Not Implemented",{},""
		if not version.upper()=="HTTP/1.1":
			return 505,"HTTP Version Not Supported",\
			{"Content-Type":"text/html","Connection":"close"},\
			"<html><body>Only HTTP/1.1 supported. Bummer.</body></html>"
	except:
		return 400,"Bad Request",{},""

def process(sock,addr):
	sock.settimeout(1)
	data=""
	d=sock.recv(4096)
	while d: # should probably use select for this, but whatever
		data+=d
		d=sock.recv(4096)
	code,msg,head,body=processRequest(data,addr)

